"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const containerAsyncRequest_1 = require("../service/containerAsyncRequest");
const createMetadataContainer_1 = require("../service/createMetadataContainer");
const createMetadataMember_1 = require("../service/createMetadataMember");
class Deploy {
    constructor(containerType, classMember, componentId, componentBody, conn) {
        this.containerType = containerType;
        this.classMember = classMember;
        this.componentId = componentId;
        this.componentBody = componentBody;
        this.conn = conn;
    }
    async deployMetadata() {
        const deployMsg = {};
        // Create MetadataContainer request
        const metadataContainerResult = await createMetadataContainer_1.createMetadataContainer(this.containerType, this.conn);
        // console.log('Metadata Container' + JSON.stringify(metadataContainerResult.id));
        if (metadataContainerResult.success) {
            // Create ApexClassMember request
            const apexClassMemberResult = await createMetadataMember_1.createMetadataMember(this.classMember, metadataContainerResult.id, this.componentBody, this.componentId, this.conn);
            // console.log('Metadata Member' + JSON.stringify(apexClassMemberResult));
            if (apexClassMemberResult.success) {
                // Create ContainerAsyncRequest request to deploy apex
                const containerAsyncResult = await containerAsyncRequest_1.createDeployRequest(metadataContainerResult.id, false, this.conn);
                if (containerAsyncResult.records[0].State === 'Completed') {
                    deployMsg.success = true;
                    deployMsg.queryResult = containerAsyncResult;
                }
                else {
                    deployMsg.success = false;
                }
            }
            else {
                deployMsg.success = false;
                deployMsg.error = JSON.stringify(apexClassMemberResult.errors);
            }
        }
        else {
            deployMsg.success = false;
            deployMsg.error = 'Metadata Container Creation Failed';
        }
        return deployMsg;
    }
}
exports.Deploy = Deploy;
//# sourceMappingURL=deploy.js.map